cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
# Create a CMakeLists.txt file to pack an arduino library into a CMake project.
# Parameters:
# -- <lib folder>: the library folder to pack.
# -- --all: pack all libraries in `$HOME/Arduino/libraries` and in
#    `$ENV{HOME}/.arduino15/packages/*/hardware/*/*/libraries`
# -- --help, -h, -help, help: print this help

function(printHelp)
    message("cmake -P PackArduinoLibrary.cmake -- [<options>]")
    message("    Pack an Arduino library inside a CMakeLists.txt file")
    message("")
    message("<lib folder>: the folder of the library to pack")
    message("--all: pack all libraries inside \$HOME/Arduino/libraries and")
    message("    in \$ENV{HOME}/.arduino15/packages/*/hardware/*/*/libraries")
    message("--help, -help, -h, help: print this help")
    message("")
endfunction(printHelp)

function(appendSet TARGET FOLDER DEPENDENCIES)
    if (NOT(("${DEPENDENCIES}" STREQUAL "")))
        file(APPEND "${FOLDER}/CMakeLists.txt"
            "set(${TARGET}\n"
            "    ${DEPENDENCIES}\n"
            ")\n"
            "\n"
        )
    else()
        file(APPEND "${FOLDER}/CMakeLists.txt"
            "set(${TARGET} )\n"
            "\n"
        )
    endif()
endfunction(appendSet)

function(getDependencies FOLDER DEPENDENCIES)
    if (NOT (EXISTS "${FOLDER}/library.properties"))
        message(WARNING "Missing 'library.properties' file")
        return()
    endif()
    file(STRINGS "${FOLDER}/library.properties" DEPS REGEX "depends *=.*$")
    string(STRIP "${DEPS}" DEPS)
    if (NOT ("${DEPS}" STREQUAL ""))
        string(SUBSTRING "${DEPS}" 7 -1 DEPS)
        string(STRIP "${DEPS}" DEPS)
        string(SUBSTRING "${DEPS}" 1 -1 DEPS)
        string(REGEX REPLACE "([A-Za-z0-9]) ([A-Za-z0-9])" "\\1_\\2" DEPS "${DEPS}")
        string(REGEX REPLACE "," " " DEPS "${DEPS}")
        string(REGEX REPLACE " +" " " DEPS "${DEPS}")
        string(REGEX REPLACE " " "\n    " DEPS "${DEPS}")
    endif()
    set(${DEPENDENCIES} "${DEPS}" PARENT_SCOPE)
endfunction(getDependencies)

function(packLibrary FOLDER)
    message("Packing: ${FOLDER}")
    get_filename_component(FOLDER "${FOLDER}" ABSOLUTE)
    if (FOLDER MATCHES ".*/$")
        string(REGEX REPLACE  "(.*)." "\\1" FOLDER "${FOLDER}")
    endif()

    file(GLOB C_MAIN LIST_DIRECTORIES false RELATIVE "${FOLDER}"  "${FOLDER}/*.c" "${FOLDER}/*.cpp")
    file(GLOB_RECURSE C_SRC FOLLOW_SYMLINKS LIST_DIRECTORIES false RELATIVE "${FOLDER}" "${FOLDER}/src/*.c" "${FOLDER}/src/*.cpp")
    list(APPEND CPP_TMP ${C_MAIN} ${C_SRC})
    set(CPP )
    foreach(FILE ${CPP_TMP})
        list(APPEND CPP "\${CMAKE_CURRENT_LIST_DIR}/${FILE}")
    endforeach(FILE CPP_TMP)


    file(GLOB S_MAIN LIST_DIRECTORIES false RELATIVE "${FOLDER}" "${FOLDER}/*.S")
    file(GLOB_RECURSE S_SRC FOLLOW_SYMLINKS LIST_DIRECTORIES false RELATIVE "${FOLDER}" "${FOLDER}/src/*.S")
    list(APPEND AS_TMP ${S_MAIN} ${S_SRC})
    set(AS )
    foreach(FILE ${AS_TMP})
        list(APPEND AS "\${CMAKE_CURRENT_LIST_DIR}/${FILE}")
    endforeach(FILE AS_TMP)

    if (IS_DIRECTORY "${FOLDER}/src")
        set(INC2 "\"\${CMAKE_CURRENT_LIST_DIR}/src\"")
    else()
        set(INC2 "")
    endif()
    list(APPEND INCS "\"\${CMAKE_CURRENT_LIST_DIR}\"" ${INC2})

    string(REGEX REPLACE ";" "\"\n    \"" CPP "${CPP}")
    string(REGEX REPLACE ";" "\"\n    \"" AS "${AS}")
    string(REGEX REPLACE ";" "\n    " INCS "${INCS}")
    if (NOT ("${CPP}" STREQUAL ""))
        set(CPP "\"${CPP}\"")
    endif()
    if (NOT ("${AS}" STREQUAL ""))
        set(AS "\"${AS}\"")
    endif()

    get_filename_component(LIB_NAME "${FOLDER}" NAME)
    getDependencies("${FOLDER}" DEPENDENCIES)

    file(WRITE "${FOLDER}/CMakeLists.txt"
        "# Automatically generated by PackArduinoLibrary.cmake\n"
        "\n"
    )
    appendSet("${LIB_NAME}_SRCS" "${FOLDER}" "${CPP}")
    appendSet("${LIB_NAME}_ASSEMBLY" "${FOLDER}" "${AS}")
    appendSet("${LIB_NAME}_INCLUDES" "${FOLDER}" "${INCS}")
    appendSet("${LIB_NAME}_DEPENDENCIES" "${FOLDER}" "${DEPENDENCIES}")
endfunction(packLibrary)

function(packAllInDir BASE)
    if (NOT(IS_DIRECTORY "${BASE}"))
        message(FATAL_ERROR "Missing library directory: ${BASE}")
    endif()
    file(GLOB DIR_LIST LIST_DIRECTORIES true "${BASE}/*")
    foreach(DIR ${DIR_LIST})
        if (IS_DIRECTORY "${DIR}")
            packLibrary("${DIR}")
        endif ()
    endforeach()
endfunction(packAllInDir)

function(packAll)
    packAllInDir("$ENV{HOME}/Arduino/libraries")

    file(GLOB DIR_LIST LIST_DIRECTORIES true "$ENV{HOME}/.arduino15/packages/*/hardware/*/*/libraries")
    foreach(DIR ${DIR_LIST})
        if (IS_DIRECTORY "${DIR}")
            packAllInDir("${DIR}")
        endif ()
    endforeach()
endfunction(packAll)

function(parseCommandLine)
    if (NOT(${CMAKE_ARGC} EQUAL 5))
        printHelp()
    endif()
    if ("${CMAKE_ARGV4}" STREQUAL "--all")
        packAll()
    elseif ("${CMAKE_ARGV4}" STREQUAL "--help"
        OR "${CMAKE_ARGV4}" STREQUAL "-help"
        OR "${CMAKE_ARGV4}" STREQUAL "-h"
        OR "${CMAKE_ARGV4}" STREQUAL "help")
        printHelp()
    else()
        packLibrary("${CMAKE_ARGV4}")
    endif()
endfunction(parseCommandLine)

parseCommandLine()
